DEF VAR sp-companycode AS CHAR NO-UNDO.

sp-companycode = "ROW".

FOR EACH ec-contract NO-LOCK WHERE
         ec-contract.companycode   = sp-companycode 
     AND ec-contract.contracttype <> "S":
  IF NOT CAN-FIND(FIRST ec-dropoff NO-LOCK WHERE
                        ec-dropoff.companycode       = ec-contract.companycode   
                    AND ec-dropoff.offhire_reference = ec-contract.contractcode
                    AND ec-dropoff.contractcode      = ec-contract.contractcode )   
  THEN RUN ecCreatePickup.
  
  IF NOT CAN-FIND(FIRST ec-dropoff NO-LOCK WHERE
                        ec-dropoff.companycode       = ec-contract.companycode   
                    AND ec-dropoff.offhire_reference = ec-contract.contractcode
                    AND ec-dropoff.contractcode      = ec-contract.contractcode )   
  THEN RUN ecCreateDropoff.
END.

PROCEDURE ecCreatePickup:
  DEF VAR cLine      AS CHAR NO-UNDO.
  DEF VAR iPickupRef AS INT  NO-UNDO.
  
  DO TRANSACTION:
    FIND ec-sequence WHERE
         ec-sequence.sequencecode = "ec-pickup" + sp-companycode
         EXCLUSIVE-LOCK.
    ASSIGN iPickupRef = (IF ec-sequence.current_value <> ?
                            THEN ec-sequence.current_value
                            ELSE ec-sequence.initial_value).
    ASSIGN ec-sequence.previous_value = iPickupRef
           ec-sequence.current_value  = ec-sequence.previous_value
                                      + ec-sequence.interval.
    CREATE ec-pickup.
    ASSIGN ec-pickup.companycode         = sp-companycode
           ec-pickup.contractcode        = ec-contract.contractcode
           ec-pickup.dt_pickup           = TODAY
           ec-pickup.dt_valid            = TODAY + 7
           ec-pickup.ind_changelocation  = TRUE
           ec-pickup.linecode            = cLine
           ec-pickup.locationcode        = "UNKNOWN"
           ec-pickup.onhire_reference    = ec-contract.contractcode
           ec-pickup.pickup_refnr        = iPickupRef  
           ec-pickup.remark              = "On hire reference for conversion".
    FOR EACH aa-container_type NO-LOCK WHERE
             aa-container_type.companycode = sp-companycode:
      CREATE ec-pickup_type.
      ASSIGN ec-pickup_type.amount_type  = 100000
             ec-pickup_type.companycode  = sp-companycode
             ec-pickup_type.pickup_refnr = iPickupRef
             ec-pickup_type.typecode     = aa-container_type.typecode.
    END.
  END.
END PROCEDURE.

PROCEDURE ecCreateDropoff:
  DEF VAR cLine      AS CHAR NO-UNDO.
  DEF VAR iDropoffRef AS INT  NO-UNDO.
  
  DO TRANSACTION:
    FIND ec-sequence WHERE
         ec-sequence.sequencecode = "ec-dropoff" + sp-companycode
         EXCLUSIVE-LOCK.
    ASSIGN iDropoffRef = (IF ec-sequence.current_value <> ?
                            THEN ec-sequence.current_value
                            ELSE ec-sequence.initial_value).
    ASSIGN ec-sequence.previous_value = iDropoffRef
           ec-sequence.current_value  = ec-sequence.previous_value
                                      + ec-sequence.interval.
    CREATE ec-dropoff.
    ASSIGN ec-dropoff.companycode          = sp-companycode
           ec-dropoff.contractcode         = ec-contract.contractcode
           ec-dropoff.dt_dropoff           = TODAY
           ec-dropoff.dt_valid             = TODAY + 7
           ec-dropoff.ind_changelocation   = TRUE
           ec-dropoff.linecode             = cLine
           ec-dropoff.locationcode         = "UNKNOWN"
           ec-dropoff.offhire_reference    = ec-contract.contractcode
           ec-dropoff.dropoff_refnr        = iDropoffRef  
           ec-dropoff.remark               = "Off hire reference for conversion".
    FOR EACH aa-container_type NO-LOCK WHERE
             aa-container_type.companycode = sp-companycode:
      CREATE ec-dropoff_type.
      ASSIGN ec-dropoff_type.amount_type   = 100000
             ec-dropoff_type.companycode   = sp-companycode
             ec-dropoff_type.dropoff_refnr = iDropoffRef
             ec-dropoff_type.typecode      = aa-container_type.typecode.
    END.
  END.
END PROCEDURE.


